; MP3 Tags
;
; From an unknown author of the German Forum
; (I would like to thanck him, he've done a big and pretty good stuff!)
; This work seems to be inspired by an article of Adam Bernstein
; that can be found at http://mpgedit.org/mpgedit/mpeg_format/mpeghdr.htm
;
; Corrected, adapted and completed by Zapman - seproject@freesoundeditor.com
;
Declare.s  DecodeMP3Tags(Pos.l)
Declare.s  DecodeCopyrightsTags()
Declare.s  ReturnTagValue (Name$,TagString$)

Global Offset
;
Procedure DemoTags()
  File$=OpenFileRequester("","","Media (MP3)|*.mp3",0)
  If ReadFile(0, File$)
    TagString$ +DecodeMP3Tags(PosInFile)+DecodeCopyrightsTags();
    MessageRequester("",ReplaceString(TagString$,"|",Chr(13)),0)
    CloseFile(0)
    ;You can extract datas like this : Debug "SampleRate = "+ ReturnTagValue ("SampleRate",TagString$)
  Else
    Debug "Can't load File"
  EndIf
EndProcedure

;DemoTags()
;End


Procedure Testbit(val,bitnum)
  ; By Zapman
  If val&(1<<(bitnum-1))
    result = 1
  EndIf
  ProcedureReturn result
EndProcedure
;
; Procedure.w Mod(a.w,b.w)
; 
;   ;gibt ganzzahligen Restwert einer Division zurck
; 
;   ProcedureReturn a - ((a/b)*b)
; EndProcedure


;################
;PFAD anpassen
;################

Procedure.s DecodeMP3Tags(HeaderStart.l)
  Protected anl$
  DError = 0
  AnalyseString.s = ""
  FileSeek(1,HeaderStart)
  mHeaderStart = HeaderStart
  cont = 1
  While cont
    While Asc(Chr(ReadByte(1))) <> $FF And HeaderStart < Lof(1)
      HeaderStart = HeaderStart + 1
    Wend
    Hbyte1.b =  ReadByte(1)
    HbyteUnsigned = Hbyte1
    If HbyteUnsigned < 0
      HbyteUnsigned + 256
    EndIf 
    If HbyteUnsigned&$D0=$D0 Or HeaderStart >=Lof(1)
      cont = 0
    EndIf
  Wend

  Offset = HeaderStart - mHeaderStart

  If HbyteUnsigned&$D0<>$D0
    DError = 1
  Else 
    
    Hbyte2.b =  ReadByte(1)
    Hbyte3.b =  ReadByte(1)
    Sam$ = Str(Testbit(Hbyte2,4))+Str(Testbit(Hbyte2,3))
    Btr$ = Str(Testbit(Hbyte2,8))+Str(Testbit(Hbyte2,7))+Str(Testbit(Hbyte2,6))+Str(Testbit(Hbyte2,5))
    Mex$ = Str(Testbit(Hbyte3,6))+Str(Testbit(Hbyte3,5))
    ;
    ;Byte 1
    ;
    Select Str(Testbit(Hbyte1,1))
    Case "0"
      ErrProtection.l = 1 ;"On"
    Case "1"
      ErrProtection   = 0 ;"Off"
    EndSelect
    Select Str(Testbit(Hbyte1,3)) + Str(Testbit(Hbyte1,2))
      Case "00"
        Layer.l = 0
      Case "01"
        Layer = 3
      Case "10"
        Layer = 2
      Case "11"
        Layer = 1
    EndSelect
    anl$ = "Layer: "+Str(Layer)
    AnalyseString + anl$ + "|"
    Select Str(Testbit(Hbyte1,5)) + Str(Testbit(Hbyte1,4))
      Case "00"
        Mpgversion.s = "2.5"
      Case "01"
        Mpgversion   = "?"
      Case "10"
        Mpgversion   = "2"
      Case "11"
        Mpgversion   = "1"
    EndSelect
    anl$ = "Mpgversion: "+Mpgversion
    AnalyseString + anl$ + "|"
    ;
    Select Mpgversion
      Case "1"
        Select Sam$
          Case "00"
            SampleRate.l = 44100
          Case "01"
            SampleRate   = 48000
          Case "10"
            SampleRate   = 32000
          Case "11"
            SampleRate   = 0
        EndSelect
      Case "2"
        Select Sam$
          Case "00"
            SampleRate   = 22050
          Case "01"
            SampleRate   = 24000
          Case "10"
            SampleRate   = 16000
          Case "11"
            SampleRate   = 0
        EndSelect
    EndSelect
    anl$ = "Samplerate: "+Str(SampleRate)
    AnalyseString + anl$ + "|"
    ;
    Select Mpgversion
    Case "1"
      Select Mex$
        Case "00"
          ModeExt$ = "Frequency band 4"
        Case "01"
          ModeExt$ = "Frequency band 8"
        Case "10"
          ModeExt$ = "Frequency band 12"
        Case "11"
          ModeExt$ = "Frequency band 16"
      EndSelect
    Case "2"
      Select Mex$
        Case "00"
          ModeExt$ = "Frequency band 0"
        Case "01"
          ModeExt$ = "Frequency band 4"
        Case "10"
          ModeExt$ = "Frequency band 8"
        Case "11"
          ModeExt$ = "Frequency band 16"
      EndSelect
    EndSelect
    anl$ = "Mode-Extension: "+ModeExt$
    AnalyseString + anl$ + "|"
    ;
    ;Byte 3
    ;
    Select Str(Testbit(Hbyte3,2)) + Str(Testbit(Hbyte3,1))
      Case "00"
        Emphasis.s = "None"
      Case "01"
        Emphasis = "50/15 microseconds"
      Case "10"
        Emphasis = "Dunno"
      Case "11"
        Emphasis = "CITT j.17"
    EndSelect
    anl$ = "Emphasis: "+Emphasis
    AnalyseString + anl$ + "|"
    ;
    Select Str(Testbit(Hbyte3,3))
      Case "0"
        Original.s = "No"
      Case "1"
        Original = "Yes"
    EndSelect
    anl$ = "Original: "+Original
    AnalyseString + anl$ + "|"
    Select Str(Testbit(Hbyte3,4))
      Case "0"
        Copyright.s = "No"
      Case "1"
        Copyright = "Yes"
    EndSelect
    anl$ = "Copyright: "+Copyright
    AnalyseString + anl$ + "|"
    
    Select Str(Testbit(Hbyte3,8))+Str(Testbit(Hbyte3,7))
      Case "00"
        Channels.l = 2 ; "Stereo"
      Case "01"
        Channels = 2;"Joint Stereo"
      Case "10"
        Channels = 2;"Dual Channels"
      Case "11"
        Channels = 1;"Mono"
    EndSelect
    anl$ = "Channels: "+Str(Channels)
    AnalyseString + anl$ + "|"
    
    ;Byte 2

    Select Str(Testbit(Hbyte2,1))
      Case "0"
        Extension.s = "None"
      Case "1"
        Extension  = "Private"
    EndSelect
    anl$ = "Extension: "+Extension
    AnalyseString + anl$ + "|"
      ;
    Select Str(Testbit(Hbyte2,2))
      Case "0"
        Padding.l = 1 ;"yes"
      Case "1"
        Padding = 0   ;"No"
    EndSelect
    anl$ = "Padding: "+Str(Padding)
    AnalyseString + anl$ + "|"


    ;Bitraten-Tabellen - Table of bitrates

    V1L1$ = "32,64,96,128,160,192,224,256,288,320,353,384,416,448,-1"
    V1L2$ = "32,48,56,64,80,96,112,128,160,192,224,256,320,384,-1"
    V1L3$ = "32,40,48,56,64,80,96,112,128,160,192,224,256,320,-1"
    V2L1$ = "32,64,96,128,160,192,224,256,288,320,352,384,416,448,-1"
    V2L2$ = "32,48,56,64,80,96,112,128,160,192,224,256,320,384,-1"
    V2L3$ = "8,16,24,32,64,80,56,64,128,160,112,128,256,320,-1"
    Liste$ ="0001,0010,0011,0100,0101,0110,0111,1000,1001,1010,1011,1100,1101,1110,1111"
    If (Layer = 1) And (Mpgversion = "1")
      Bitrate$ = StringField(V1L1$,((FindString(Liste$,Btr$,0)-1)/4)-1,",")
    EndIf
    If (Layer = 2) And (Mpgversion = "1")
      Bitrate$ = StringField(V1L2$,((FindString(Liste$,Btr$,0)-1)/4)-1,",")
    EndIf
    If (Layer = 3) And (Mpgversion = "1")
      Bitrate$ = StringField(V1L3$,((FindString(Liste$,Btr$,0)-1)/4)-1,",")
    EndIf
    If (Layer = 1) And (Mpgversion = "2")
      Bitrate$ = StringField(V2L1$,((FindString(Liste$,Btr$,0)-1)/4)-1,",")
    EndIf
    If (Layer = 2) And (Mpgversion = "2")
      Bitrate$ = StringField(V2L2$,((FindString(Liste$,Btr$,0)-1)/4)-1,",")
    EndIf
    If (Layer = 3) And (Mpgversion = "2")
      Bitrate$ = StringField(V2L3$,((FindString(Liste$,Btr$,0)-1)/4)-1,",")
    EndIf
    anl$ = "Bitrate (kBits/s): "+Bitrate$
    AnalyseString + anl$ + "|"

    ;rechnen - Calcul de la taille et du nombre de frames

    If SampleRate =0
      DError = 2
    Else
      If Val(Bitrate$) > 0 And SampleRate > 0
        Sek.l = Int(Lof(1) * 8) / (Val(Bitrate$) *1000)
      EndIf
      anl$ = "Duration (sec): "+Str(Sek)
      AnalyseString + anl$ + "|"

      ;Min =  Sek/60
      ;Seks = Mod(Sek,60)

      anl$ = "Time (min): "+Str(Sek/60)+":"+Str(Mod(Sek,60))
      AnalyseString + anl$ + "|"

      If Layer = 1
        FrameLength = ((12 * 1000 * Val(BitRate$) / SampleRate) + Padding) * 4 
      Else 
        FrameLength = (144 * 1000 * Val(BitRate$) / SampleRate) + Padding
      EndIf

      anl$ = "FrameLength (bytes): "+Str(FrameLength)
      AnalyseString + anl$ + "|"
      If FrameLength > 0
        Frames.l = (Lof(1)-128-Headerstart) / (FrameLength)
      EndIf
      anl$ = "Frames: "+Str(Frames)
      AnalyseString + anl$ + "|"

    EndIf
  EndIf
  If DError
    AnalyseString = "Error "+Str(DError)
  EndIf
  ProcedureReturn AnalyseString
EndProcedure
;
Procedure.s DecodeCopyrightsTags()
  AnalyseString.s = ""
  ; ID3V1-Tag auslesen , die letzten 128 Bytes der Datei
  ; Additionnal ID3V1 datas are at the end of the file

  FileSeek(1,Lof(1)-128)
  *mem = AllocateMemory(128)
  ReadData(1,*mem,128)
  Tags$ = PeekS(*mem,3)
  If tags$ = "TAG"
    anl$ = "ID3V1-Tag: "

    ;Debug PeekS(MemoryID(),3);TAG-Kennung

    anl$ + PeekS(*mem+3,30);Title
    anl$ +" - "+ PeekS(*mem+33,30);Artist
    anl$ +" - "+ PeekS(*mem+63,30);Album
    anl$ +" - "+ PeekS(*mem+93,4);Date
    anl$ +" - "+ PeekS(*mem+97,29);Commentaries
    anl$ +" - "+ Str(PeekB(*mem+126));Track-NR
    Restore Genre
    For x = 0 To PeekB(*mem+127);Genre-ID
      Read.s Genre$
    Next x
    AnalyseString + Genre$ + "|"

  EndIf
  FreeMemory(*mem)

  ;ID3V2-Tag auslesen! Variable Lnge am Anfang der Datei.
  ;Das Ganze ist leider nicht ganz so einfach, da
  ;im Prinzip jedes Programm,das TAG's einfuegen kann,
  ;reinschreiben kann was es will !
  ;Es gibt zwar einige Vorgaben, aber das reicht bei weitem nicht aus !
  ;Alle nicht bekannten Frame-Formate werden mit "unbekannt"
  ;gekennzeichnet !
  HeaderStart = 0
  FileSeek(1,0)
  While Asc(Chr(ReadByte(1))) <> $FF And HeaderStart < Lof(1)
    HeaderStart = HeaderStart + 1
  Wend
  If Headerstart > 0
    FileSeek(1,0);zum Anfang

    ;die ersten 10 Bytes einlesen

    Dim bytes.b(9)
    For x = 0 To 9
      Bytes(x) = ReadByte(1)
    Next x
    ID3Ident$ = Chr(Bytes(0))+Chr(Bytes(1))+Chr(Bytes(2))

    ;Debug ID3Ident$

    ID3Version.l = Bytes(3)
    ID3SubVersion.l = Bytes(4)
    ID3Flags.l = Bytes(5)
    anl$ = "ID3V2-Version: " +Str(ID3Version)+"."+Str(ID3SubVersion)
    AnalyseString + anl$ + "|"

    ;Debug ID3Flags
    ;die nchsten 4 Bytes sind die Lngenangabe
    ;brauchen wir nicht da die Lnge schon
    ;bekannt ist (Headerstart-1)

    anl$ = "ID3V2Size (bytes): "+ Str(Headerstart-1)
    AnalyseString + anl$ + "|"

    ;Extendet Header vorhanden ?
    ;Ist der Header vorhanden verschieben sich die
    ;Frames um 6 Bytes nach hinten

    ExtHeader.l = Testbit(Bytes(5),6)

    ;ExtHeader
    ;Frames auslesen

    If Extheader > 0
      FrameStart = 16
    Else
      FrameStart = 10
    EndIf

    ;unterschiedliche Behandlung der Versionen
    ;Versionen 3.x und 4.x bearbeiten

    If ID3Version = 3 Or ID3Version = 4
      DescriptPlus = 11
      Repeat
        FileSeek(1,FrameStart);zum Anfang
        FrameID$ = Chr(ReadByte(1))+Chr(ReadByte(1))+Chr(ReadByte(1))+Chr(ReadByte(1))

        ; FrameID$

        FrameLength   = ReadByte(1)*256*8*8
        FrameLength   + ReadByte(1)*256*8
        FrameLength   + ReadByte(1)*256
        FrameLength   + ReadByte(1)
        DescriptionStart = FrameStart + DescriptPlus
        If FrameLength <> 0 ; sonst berlauf
          FileSeek(1,DescriptionStart)
          *mem=AllocateMemory(FrameLength-1)
          ReadData(1,*mem,FrameLength-1)

          ;Winamp schreibt da komisches Zeug rein
          ;wahrscheinlich einen Sprachbezeichner
          ;den brauchen wir nicht, also weg damit

          Frame$ = PeekS(*mem,FrameLength-1)
          If FrameID$ = "COMM";Sprachbezeichner 3 Zeichen und NULLByte
            Frame$ = PeekS(*mem+4,FrameLength-1)
          EndIf
          If FrameId$ = "WXXX";Link fngt mit NULLByte an
            Frame$ = PeekS(*mem+1,FrameLength-1)
          EndIf
          FreeMemory(*mem)
          Select FrameID$
            Case "PCNT"
              Framename$ = "Play Counter: "+Frame$
            Case "TRCK"
              Framename$ = "Track: "+Frame$
            Case "TENC"
              Framename$ = "Encoded with: "+Frame$
            Case "WXXX"
              Framename$ = "Link: "+Frame$
            Case "TCOP"
              Framename$ = "Copyright (c): "+Frame$
            Case "TOPE"
              Framename$ = "Editor: "+Frame$
            Case "TCOM"
              Framename$ = "Composer: "+Frame$
            Case "TCON"
              If Left(Frame$,1)="("
                Frame$=Right(Frame$,Len(Frame$)-1)
                Frame$=Left(Frame$,Len(Frame$)-1)
                Restore Genre
                For x = 0 To Val(Frame$);Genre-ID
                  Read.s Genre$
                Next x
                Frame$ = Genre$
              EndIf
              Framename$ = "Genre: "+Frame$
            Case "COMM"
              Framename$ = "Commentaries: "+Frame$
            Case "TYER"
              Framename$ = "Date: "+Frame$
            Case "TALB"
              Framename$ = "Album: "+Frame$
            Case "TPE1"
              Framename$ = "Artist: "+Frame$
            Case "TIT2"
              Framename$ = "Title: "+Frame$
            Case "TLAN"
              Framename$ = "Language: "+Frame$
            Case "TLEN"
              Framename$ = "Dure: "+Frame$
            Case "TMED"
              Framename$ = "Media: "+Frame$
            Case "TPUB"
              Framename$ = "Publisher: "+Frame$
            Case "TSSE"
              Framename$ = "Decoding-Software: "+Frame$

              ;            Default
              ;            Framename$ = "Frame-Format:"+Frame$

          EndSelect
          If Frame$ <> ""
            AnalyseString + Framename$ + "|"
          EndIf
        EndIf
        FrameStart + DescriptPlus + FrameLength -1
      Until FrameID$ = "" Or FrameID$ = "3DI";NULL Oder Footer
    EndIf

    ;Version 2.x bearbeiten

    If ID3Version = 2
      DescriptPlus = 6
      FrameLength = 0
      FrameStart = 10
      Repeat
        FileSeek(1,FrameStart);zum Anfang
        FrameID$ = Chr(ReadByte(1))+Chr(ReadByte(1))+Chr(ReadByte(1))
        FrameLength = 0
        FrameLength   + Asc(Chr(ReadByte(1)))*256*8
        FrameLength   + Asc(Chr(ReadByte(1)))*256
        FrameLength   + Asc(Chr(ReadByte(1)))
        ReadByte(1)
        If FrameLength > 0;sonst berlauf
          *mem=AllocateMemory(FrameLength-1)
          ReadData(1,*mem,FrameLength-1)

          ;Sprachbezeichner ausfiltern

          Frame$ = PeekS(*mem,FrameLength-1)
          For i = 1 To 4
            If Mid(Frame$,i,1) = Chr(0)
              Frame$ = PeekS(*mem+4,FrameLength-1)
            EndIf
          Next I

          FreeMemory(*mem)
          Select FrameID$
            Case "TRK"
              Framename$ = "Track: "+Frame$
            Case "TEN"
              Framename$ = "Encoded with: "+Frame$
            Case "TCR"
              Framename$ = "Copyright (c): "+Frame$
            Case "TOA"
              Framename$ = "Editor: "+Frame$
            Case "TCM"
              Framename$ = "Composer: "+Frame$
            Case "TCO"
              If Left(Frame$,1)="("
                Frame$=Right(Frame$,Len(Frame$)-1)
                Frame$=Left(Frame$,Len(Frame$)-1)
                Restore Genre
                For x = 0 To Val(Frame$);Genre-ID
                  Read.s Genre$
                Next x
                Frame$ = Genre$
              EndIf
              Framename$ = "Genre: "+Frame$
            Case "COM"
              Framename$ = "Commentaries: "+Frame$
            Case "TYE"
              Framename$ = "Date: "+Frame$
            Case "TAL"
              Framename$ = "Album: "+Frame$
            Case "TP1"
              Framename$ = "Artist: "+Frame$
            Case "TT2"
              Framename$ = "Title: "+Frame$
            Case "TLA"
              Framename$ = "Language: "+Frame$
            Case "TMT"
              Framename$ = "Media: "+Frame$
            Case "TSS"
              Framename$ = "Decoding-Software: "+Frame$
            Default
              Framename$ = "Frame-Format: "+Frame$
          EndSelect
          If Frame$ <> ""
            AnalyseString + Framename$ + "|"
          EndIf
        EndIf
        FrameStart + FrameLength + DescriptPlus
      Until FrameLength = 0
    EndIf
  EndIf
  ProcedureReturn AnalyseString
EndProcedure
;
Procedure.s ReturnTagValue (ValName$,TagString$)
  TagString$ = "||"+TagString$
  p = FindString(LCase(TagString$),"|"+LCase(ValName$)+":",0)
  If p<1
    p = FindString(LCase(TagString$),"|"+LCase(ValName$)+" (",0)
  EndIf
  If p>0
    While Mid(TagString$,p,1)<>":" And p<Len(TagString$): p + 1 : Wend
    p + 1
    p2 = FindString(TagString$,"|",p) - p
    ProcedureReturn Trim(Mid(TagString$,p,p2))
  Else
    ProcedureReturn "Error"
  EndIf
EndProcedure


DataSection
  Genre:
  Data.s "Blues"
  Data.s "Classic Rock"
  Data.s "Country"
  Data.s "Dance"
  Data.s "Disco"
  Data.s "Funk"
  Data.s "Grunge"
  Data.s "Hip-Hop"
  Data.s "Jazz"
  Data.s "Metal"
  Data.s "New Age"
  Data.s "Oldies"
  Data.s "Other"
  Data.s "Pop"
  Data.s "R&B"
  Data.s "Rap"
  Data.s "Reggae"
  Data.s "Rock"
  Data.s "Techno"
  Data.s "Industrial"
  Data.s "Alternative"
  Data.s "Ska"
  Data.s "Death Metal"
  Data.s "Pranks"
  Data.s "Soundtrack"
  Data.s "Euro-Techno"
  Data.s "Ambient"
  Data.s "Trip-Hop"
  Data.s "Vocal"
  Data.s "Jazz Funk"
  Data.s "Fusion"
  Data.s "Trance"
  Data.s "Classical"
  Data.s "Instrumental"
  Data.s "Acid"
  Data.s "House"
  Data.s "Game"
  Data.s "Sound Clip"
  Data.s "Gospel"
  Data.s "Noise"
  Data.s "AlternRock"
  Data.s "Bass"
  Data.s "Soul"
  Data.s "Punk"
  Data.s "Space"
  Data.s "Meditative"
  Data.s "Instrumental Pop"
  Data.s "Instrumental Rock"
  Data.s "Ethnic"
  Data.s "Gothic"
  Data.s "Darkwave"
  Data.s "Techno-Industrial"
  Data.s "Electronic"
  Data.s "Pop-Folk"
  Data.s "Eurodance"
  Data.s "Dream"
  Data.s "Southern Rock"
  Data.s "Comedy"
  Data.s "Cult"
  Data.s "Gangsta"
  Data.s "Top 40"
  Data.s "Christian Rap"
  Data.s "Pop/Funk"
  Data.s "Jungle"
  Data.s "Native American"
  Data.s "Cabaret"
  Data.s "New Wave"
  Data.s "Psychadelic"
  Data.s "Rave"
  Data.s "Showtunes"
  Data.s "Trailer"
  Data.s "Lo-Fi"
  Data.s "Tribal"
  Data.s "Acid-Punk"
  Data.s "Acid-Jazz"
  Data.s "Polka"
  Data.s "Retro"
  Data.s "Musical"
  Data.s "Rock & Roll"
  Data.s "Hard Rock"
  Data.s "Folk"
  Data.s "Folk-Rock"
  Data.s "National Folk"
  Data.s "Swing"
  Data.s "Fast Fusion"
  Data.s "Bebob"
  Data.s "Latin"
  Data.s "Revival"
  Data.s "Celtic"
  Data.s "Bluegrass"
  Data.s "Avantgarde"
  Data.s "Gothic Rock"
  Data.s "Progressive Rock"
  Data.s "Psychedelic Rock"
  Data.s "Symphonic Rock"
  Data.s "Slow Rock"
  Data.s "Big Band"
  Data.s "Chorus"
  Data.s "Easy Listening"
  Data.s "Acoustic"
  Data.s "Humour"
  Data.s "Speech"
  Data.s "Chanson"
  Data.s "Opera"
  Data.s "Chamber Music"
  Data.s "Sonata"
  Data.s "Symphony"
  Data.s "Booty Bass"
  Data.s "Primus"
  Data.s "Porn Groove"
  Data.s "Satire"
  Data.s "Slow Jam"
  Data.s "Club"
  Data.s "Tango"
  Data.s "Samba"
  Data.s "Folklore"
  Data.s "Ballad"
  Data.s "Power Ballad"
  Data.s "Rhythmic Soul"
  Data.s "Freestyle"
  Data.s "Duet"
  Data.s "Punk Rock"
  Data.s "Drum Solo"
  Data.s "A Capella"
  Data.s "Euro-House"
  Data.s "Dance Hall"
  Data.s "Goa"
  Data.s "Drum & Bass"
  Data.s "Club-House"
  Data.s "Hardcore"
  Data.s "Terror"
  Data.s "Indie"
  Data.s "BritPop"
  Data.s "Negerpunk"
  Data.s "Polsk Punk"
  Data.s "Beat"
  Data.s "Christian Gangsta Rap"
  Data.s "Heavy Metal"
  Data.s "Black Metal"
  Data.s "Crossover"
  Data.s "Contemporary Christian"
  Data.s "Christian Rock"
  Data.s "Merengue"
  Data.s "Salsa"
  Data.s "Thrash Metal"
  Data.s "Anime"
  Data.s "JPop"
  Data.s "Synthpop"
EndDataSection
; IDE Options = PureBasic 5.24 LTS (Windows - x86)
; CursorPosition = 526
; FirstLine = 524
; Folding = -